#! /bin/sh
# How translation works: 	(for the commands see below)
# you have a .pot (.po-template) file which is for all languages the same.
# you have an .po file for each language. You edit it with poedit (or another editor). There you translate.
# you make an machine-readable version of it, the .mo file.
# it must be stored in the folder translations/de/LC_MESSAGES/wesnoth-Era_of_Myths.mo 

#if you change something in the game, you must generate a new .pot and merge the old .po file (containing translations) with the new .pot. The result is a new .po file containing the translations.


# Window users:  you may get this script running with >>cygwin<<

#Tools:
#you have to have gnu gettext installed, and need the wmlxgettext script. poedit ist the editor of choice.
# wmlxgettext is possibly in your game_folder/utils/wmlxgettext. Possibly you have to install a paket called wesnoth-tools or wesnoth-1.xy-tools. If not, download it from the wesnoth developers server andmake sure that the command below knows the location of the wmlxgettext script.


#generate .pot 
#there must be all *.cfg files which have written in their first line >>#textdomain wesnoth-Era_of_Myths<<.
#This are in fact all *.cfg files besides a few ones which start with >>#wmllint: no translatables<<
#It are around 200 *.cfg files.
echo ./mainline-strings.cfg ./macros/abilities.cfg ./macros/amla.cfg ./macros/traits.cfg ./macros/names.cfg ./macros/special-notes.cfg ./macros/specials.cfg ./macros/ferocious.cfg ./units/celestials.cfg ./units/therians/e2_Defender.cfg ./units/therians/f3_Aura_Master.cfg ./units/therians/x1_Apprentice.cfg ./units/therians/x3_Priest.cfg ./units/therians/f1_Monk.cfg ./units/therians/a1_Falcon.cfg ./units/therians/c2_Sea_Snake.cfg ./units/therians/b1_Cat.cfg ./units/therians/f2_Aura_Monk.cfg ./units/therians/a3_Gyrfalcon.cfg ./units/therians/d2_Tracker.cfg ./units/therians/d3_Ranger.cfg ./units/therians/x2_Mage.cfg ./units/therians/a2_Prairie_Falcon.cfg ./units/therians/c2_Sandskipper.cfg ./units/therians/b2_Wildcat.cfg ./units/therians/c3_Spitting_Cobra.cfg ./units/therians/a3_Peregrine_Falcon.cfg ./units/therians/d1_Hunter.cfg ./units/therians/x2_Shaman.cfg ./units/therians/c3_King_Cobra.cfg ./units/therians/b3_Panther.cfg ./units/therians/b3_Tiger.cfg ./units/therians/c2_Cobra.cfg ./units/therians/e1_Guard.cfg ./units/therians/x3_Master.cfg ./units/therians/c1_Serpent.cfg ./units/elementals.cfg ./units/therians.cfg ./units/windsong/e2_Heretic.cfg ./units/windsong/e3_Oathkeeper.cfg ./units/windsong/d1_Seeker.cfg ./units/windsong/a3_Dreadnought.cfg ./units/windsong/d2_Pathfinder.cfg ./units/windsong/f4_Librarian.cfg ./units/windsong/e3_Harbinger.cfg ./units/windsong/a2_Emissary.cfg ./units/windsong/f2_Savant.cfg ./units/windsong/d2_Skyrunner.cfg ./units/windsong/b1_Sky_Crystal.cfg ./units/windsong/b0_Sky_Shard.cfg ./units/windsong/f3_Runeforger.cfg ./units/windsong/c3_Ascendant.cfg ./units/windsong/a2_Reaver.cfg ./units/windsong/f3_Arbiter.cfg ./units/windsong/d3_Farstrider.cfg ./units/windsong/c3_Herald.cfg ./units/windsong/a1_Courier.cfg ./units/windsong/e2_Lorekeeper.cfg ./units/windsong/c1_Weaver.cfg ./units/windsong/c2_Prophet.cfg ./units/windsong/c2_Envoy.cfg ./units/windsong/d3_Stormbringer.cfg ./units/windsong/e1_Gatekeeper.cfg ./units/windsong/f1_Scribe.cfg ./units/devlings.cfg ./units/elementals/c2_Rock_Golem.cfg ./units/elementals/c1_Earth_Elemental.cfg ./units/elementals/d2_Undine.cfg ./units/elementals/a3_Fire_Ghost.cfg ./units/elementals/a2_Living_Furnace.cfg ./units/elementals/d3_Tempest_Spirit.cfg ./units/elementals/b2_Zephyr.cfg ./units/elementals/f2_Vine_Tiger.cfg ./units/elementals/d3_Ice_Shell.cfg ./units/elementals/b1_Razorbird.cfg ./units/elementals/b1_Wind_Spirit.cfg ./units/elementals/d1_Water_Elemental.cfg ./units/elementals/b2_Thunderbird.cfg ./units/elementals/f1_Vine_Beast.cfg ./units/elementals/a1_Fire_Elemental.cfg ./units/elementals/e2_Silver_Unicorn.cfg ./units/elementals/a3_Lava_Beast.cfg ./units/elementals/b0_Air_Elemental.cfg ./units/elementals/e1_Unicorn.cfg ./units/elementals/c3_Stone_Titan.cfg ./units/elementals/b3_Djinn.cfg ./units/elementals/a2_Fire_Wisp.cfg ./units/elementals/d2_Ice_Crab.cfg ./units/wargs/e1_Fire_Sprite.cfg ./units/wargs/b2_Shadow_Pelt.cfg ./units/wargs/a2_Changeling.cfg ./units/wargs/d1_Wolf.cfg ./units/wargs/g2_Water_Nymph.cfg ./units/wargs/c1_Warrior_Wolf.cfg ./units/wargs/e3_Flame_Spirit.cfg ./units/wargs/c3_Pack_Leader.cfg ./units/wargs/f2_Black_Hunter.cfg ./units/wargs/c2_Rabid_Wolf.cfg ./units/wargs/d0_Wolf_Cub.cfg ./units/wargs/a3_Wolfling.cfg ./units/wargs/c3_Fenrir.cfg ./units/wargs/e2_Flame_Sprite.cfg ./units/wargs/b1_Stalker.cfg ./units/wargs/a1_Shapeshifter.cfg ./units/wargs/g1_Water_Dryad.cfg ./units/wargs/g3_Water_Shyde.cfg ./units/wargs/c2_Warrior_Warg.cfg ./units/wargs/c3_Moon_Blade.cfg ./units/wargs/d2_Dire_Wolf.cfg ./units/wargs/b3_Night_Eye.cfg ./units/wargs/f1_Blackfur.cfg ./units/wargs/c4_Garou.cfg ./units/celestials/e2_Great_Wizard.cfg ./units/celestials/a3_Holy_Sentinel.cfg ./units/celestials/f1_Zealot.cfg ./units/celestials/e3_Prophet.cfg ./units/celestials/e3_Sage.cfg ./units/celestials/a2_Divine_Knight.cfg ./units/celestials/b3_Sentinel.cfg ./units/celestials/d2_Claimant.cfg ./units/celestials/c1_Light_Spirit.cfg ./units/celestials/a2_Quester.cfg ./units/celestials/c3_Master_of_Light.cfg ./units/celestials/a2_Protector.cfg ./units/celestials/d4_Seraphin.cfg ./units/celestials/d1_Messenger.cfg ./units/celestials/c2_Lantern_Archon.cfg ./units/celestials/e2_Mystic.cfg ./units/celestials/b2_Keeper.cfg ./units/celestials/f2_Militant.cfg ./units/celestials/e1_Wizard.cfg ./units/celestials/d3_Herald.cfg ./units/celestials/a3_Divine_Champion.cfg ./units/celestials/f3_Sicarius.cfg ./units/celestials/b1_Legionnaire.cfg ./units/celestials/a1_Crusader.cfg ./units/vampires/g2_Blood_Hulk.cfg ./units/vampires/a2_Flesh_Artisan.cfg ./units/vampires/d2_Half_Blood.cfg ./units/vampires/c3_Sire.cfg ./units/vampires/c2_Duelist.cfg ./units/vampires/f2_Marlgoyle.cfg ./units/vampires/c2_Noble.cfg ./units/vampires/c3_Sword_Dancer.cfg ./units/vampires/a3_Sangel.cfg ./units/vampires/d1_Thin_Blood.cfg ./units/vampires/b0_Bloodborn.cfg ./units/vampires/a1_Blood_Apprentice.cfg ./units/vampires/d3_Day_Hunter.cfg ./units/vampires/c1_Fledgeling.cfg ./units/vampires/d3_Twilight_Walker.cfg ./units/vampires/b1_Malborn.cfg ./units/vampires/c4_Methusalem.cfg ./units/vampires/a2_Blood_Manipulator.cfg ./units/vampires/f1_Gargoyle.cfg ./units/warg.cfg ./units/windsong.cfg ./units/vampires.cfg ./units/devlings/c3_Hero.cfg ./units/devlings/b3_Staplers.cfg ./units/devlings/e4_Abusers.cfg ./units/devlings/c2_Warrior.cfg ./units/devlings/b2_Spikers.cfg ./units/devlings/a1_Flappers.cfg ./units/devlings/a2_Flyers.cfg ./units/devlings/c2_Soldier.cfg  ./units/devlings/d0_Sneak.cfg ./units/devlings/c3_Chief.cfg ./units/devlings/b1_Nailers.cfg ./units/devlings/c1_Overgrown.cfg ./units/devlings/e3_Offenders.cfg ./units/devlings/a3_Attackers.cfg ./units/devlings/e1_Cursers.cfg ./units/devlings/d1_Lurker.cfg ./units/devlings/e2_Blasphemists.cfg ./factions/therians-POWER.cfg ./factions/celestials-EOM.cfg ./factions/celestials-RECRUIT.cfg ./factions/devlings-EOM.cfg ./factions/vampires-EOM.cfg ./factions/windsong-EOM.cfg ./factions/elementals-RECRUIT.cfg ./factions/therians-EOM.cfg ./factions/vampires-POWER.cfg ./factions/vampires-RECRUIT.cfg ./factions/windsong-POWER.cfg ./factions/wargs-POWER.cfg ./factions/devlings-RECRUIT.cfg ./factions/wargs-RECRUIT.cfg ./factions/therians-RECRUIT.cfg ./factions/devlings-POWER.cfg ./factions/wargs-EOM.cfg ./factions/elementals-POWER.cfg ./factions/windsong-RECRUIT.cfg ./factions/elementals-EOM.cfg ./factions/celestials-POWER.cfg ./EOM_eras.cfg | xargs wmlxgettext --directory=. --domain=wesnoth-Era_of_Myths > wesnoth-Era_of_Myths.pot

#create new .po file - not needed since we have already existing translations - only when starting a brand new translation
##msginit --no-translator --input=wesnoth-Era_of_Myths.pot --output-file=de.po --locale=de

# MAKE SURE you have somewhere an backup
#cp translations/de/LC_MESSAGES/wesnoth-Era_of_Myths.po my_personal_backup_file which I delete later again

#merge old.po file (containing the translations) into the new.po(t) file
msgmerge  --previous -U translations/de/LC_MESSAGES/wesnoth-Era_of_Myths.po wesnoth-Era_of_Myths.pot
msgmerge  --previous -U translations/la/LC_MESSAGES/wesnoth-Era_of_Myths.po wesnoth-Era_of_Myths.pot
#-U, --update		update old.po, do nothing if old.po already up to date
#    --backup=CONTROL	make a backup of old.po (didn't test it myself)
#    --previous 	keep previous msgids of translated messages
#due to using the -U option, the existing.po file will be changed and the .pot file not
#(otherwise the .po remains untouched and the .pot get's filled with the translations)
# Note that you can use msgmerge to merge two .po files as well


#generate .mo files after translation work in the .po file is done
#msgfmt translations/de/LC_MESSAGES/wesnoth-Era_of_Myths.po --output-file=translations/de/LC_MESSAGES/wesnoth-Era_of_Myths.mo
#(this overwrites the existing .mo !)

#WHAT IF ... You lost the .po file containing the translations or had none to begin with, but have the .mo file?
#You can get the .po file back with
# msgunfmt file.mo > file.po


# SUMMARY:
# To get it 'up to date' do like shown above:
# generate a new .pot file
# merge the translated .po file with that one. Don't mix the order of the arguments.
# make your translation work (in the now merged .po file). poedit recommended.
# generate .mo file from it. (if you save in poedit it get's done automatically)
# move it to the right location
# eventually delete the wesnoth cache. In the game go to >> settings -> directorys << There is written where the cache is located

#empty the cache
#rm  -f ~/.cache/wesnoth/*

#if you still don't see the "new" translation, start a new game instead of loading a savefile.
#Often this is the solution of the problem.

